/*
 * * * Compile_AHK SETTINGS BEGIN * * *

[AHK2EXE]
Exe_File=%In_Dir%\CommentExplorer.exe
No_UPX=1
[VERSION]
Set_Version_Info=1
File_Description=CommentExplorer
File_Version=2.5.0.0
Inc_File_Version=0
Legal_Copyright=2015 http://milesaheadsoftware.org
Original_Filename=CommentExplorer.exe
Product_Name=Comment Explorer
Product_Version=2.5.0.0
[ICONS]
Icon_1=%In_Dir%\C.ico

* * * Compile_AHK SETTINGS END * * *
*/

#SingleInstance force
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
OnExit,SaveIni
#Include MilesAhead.ahk
progname := _FileBaseName(A_ScriptFullPath)
tiptext := progname . "  =//=>"
ArrowsEnabled := 0
FolderMode := 0
PrevFolder := ""
CurrentFolder := "$$$"
ClipSaved := ""
UseProg := 0
UseDelay := 0
TaskInit := 0
TempStr := ""
FoundFiles := ""
ProgTitle := "Compacting Comments"
IniFile = %A_ScriptDir%\%A_ScriptName%
IniFile := RegExReplace(IniFile,"i)ahk$","ini")
IniFile := RegExReplace(IniFile,"i)exe$","ini")
IniRead,FolderMode,%IniFile%,Settings,FolderMode,0
if FolderMode
  tiptext .= " F"
IniRead,ArrowsOn,%IniFile%,Settings,ArrowsEnabled,1

Menu Tray,NoStandard
Menu Tray,Add,Donate,DoDonate
Menu Tray,Add,Visit Hotkey Page,DoVisit
Menu Tray,Add,Check for Update,CheckUpdate
Menu Tray,Add
Menu Tray,Add,Show Readme,DoReadme
Menu Tray,Add,About,DoAbout
Menu Tray,Add,Edit Ini File,DoIniFile
Menu Tray,Add
if !FolderMode
  Menu Tray,Add,Purge Comments,PurgeComments
Menu Tray,Add,Compact Comments,CompactComments
Menu Tray,Add,Back Up Comments,BackupComments
Menu Tray,Add,Search Comments,SearchComments
Menu Tray,Add
Menu Tray,Add,Arrow ToolTips,ToggleTips
Menu Tray,Add,Quit,DoQuit
Menu Tray,Default,Arrow ToolTips
if (A_IsCompiled)
  Menu Tray,Icon,%A_ScriptFullPath%,1
Menu Tray,Tip,%tiptext%
if ArrowsOn
  gosub,ToggleTips
gosub,WriteIni

if FolderMode
  gosub,DisableFileFuncs

hModule := 0
if (_WinVersion() >= 6.1)
  hModule := DllCall("LoadLibrary", Str,"Win7TaskbarLib.dll")
GroupAdd,ExplorerGroup, ahk_class CabinetWClass
GroupAdd,ExplorerGroup, ahk_class ExploreWClass
TipActive := 0
FileName := ""
CommentFile := "Comments.txt"
SearchResults := "SearchResults.txt"
CommentBackup := CommentFile . ".bak"
FolderCommentFileName := "CommentExplorerFolderData.txt"

sd := ComObjCreate("Scripting.Dictionary")
if !IsObject(sd)
{
  MsgBox, 4112, Comment Explorer, Comment Dictionary Creation Failed!
  ExitApp
}
FileBusy := 0
InputBusy := 0
IniEditActive := 0
if !FolderMode
  gosub,ReadCommentFile
return

~Esc::
  if TipActive
    gosub,ClearTip  
Return

#IfWinActive, ahk_Group ExplorerGroup
~LButton::
~Up::
~Down::
  if TipActive
  {
     gosub,ClearTip
     return
   }
  if FileBusy
    Return
  if !ArrowsEnabled
    Return
  FileName := Explorer_GetSelection()
  key := FileName
  if FolderMode
  {
    CurrentFolder := _FileDir(FileName)
    if (CurrentFolder != PrevFolder)
    {
      PrevFolder := CurrentFolder
      if sd.count > 0
        sd.removeall()
      CommentFile := _FileDirWithSlash(FileName) . FolderCommentFileName
      ;MsgBox, 4160, Comment Explorer, Comment File is: %CommentFile%, 5
      gosub,ReadCommentFile
      gosub,EnableFileFuncs
    }
    key := _FileName(FileName)
  }
  if sd.exists(key)
   {
      Str := sd.item(key)
      WinGetPos, xpos, ypos, , , A
      ClipSaved := Clipboard
      Clipboard := Str
      Progress, zh0 B fs12 X%xpos% Y%ypos%, %Str%
      TipActive := 1
   }
Return

+F11::
  if FileBusy
    Return
  if InputBusy
    Return
  FileName := Explorer_GetSelection()
  InputBusy := 1
  _CommentFiles(FileName)
  InputBusy := 0
Return

^F11::
  if FileBusy
    Return
  if InputBusy
    Return
  FileName := Explorer_GetSelection()
  FileBusy := 1
  _CopyComments(FileName)
  FileBusy := 0
Return

ClearTip:
  if TipActive
  {
    Progress, OFF
    TipActive := 0
    if (Clipboard == Str)
      Clipboard := ClipSaved
  }
Return

ReadCommentFile:
  FileBusy := 1
  IfNotExist,%CommentFile%
  {
    FileBusy := 0
    Return
  }
  FileRead,Contents,%CommentFile%
  if !Contents
  {
    FileBusy := 0
    Return
  }
  Loop, parse, Contents, `n, `r
  {
   if Mod(A_Index,2)
      keystr := A_LoopField
   else
      sd.item(keystr) := A_LoopField
  }
  FileBusy := 0
Return

ToggleTips:
  ArrowsEnabled := !ArrowsEnabled
  Menu Tray,ToggleCheck,Arrow ToolTips
  if ArrowsEnabled
    tiptext := progname . "  ==>"
  else
    tiptext := progname . "  =//=>"
  if FolderMode
    tiptext .= " F"
  Menu Tray,Tip,%tiptext%
  gosub,WriteIni
Return

DoAbout:
  FileGetVersion,filever,%progname%.exe
  MyMsg =
  (
%progname% v %filever% Copyright (c)  %A_Year% milesaheadsoftware.org`n
Use Up Down Arrows to see Comments in Explorer`n
Press Shift-F11 to Add Comment(s) for File(s)`n
Press Control-F11 to Copy Comments to another Folder
  )
  MsgBox, 4160, About %progname%, %MyMsg%
Return

DoDonate:
  Run,"http://milesaheadsoftware.org"
Return

DoVisit:
  Run,"http://milesaheadsoftware.org"
Return

PurgeComments:
  EntriesPurged := 0
  FileBusy := 1
  for k, v in sd.Keys()
  {
    if sd.exists(k)
    {
      IfNotExist,%k%
      {
        sd.remove(k)
        EntriesPurged += 1
      }
    }
  }
  OldProgTitle := ProgTitle
  ProgTitle := "Purging Comments"
  gosub,CompactComments
  ProgTitle := OldProgTitle
  MsgBox, 4160, Comment Explorer, %EntriesPurged% Entries Purged, 5
  FileBusy := 0
Return

CompactComments:
  WhileLoopCount := 20
  if (sd.count = 0)
  {
    FileBusy := 0
    MsgBox, 4160, Comment Explorer, No Comments to Compact, 4
    Return
  }  
  if FolderMode
  {
    MsgBox, 4132, Comment Explorer, This Will Compact Comments in:`n`n %CommentFile% `n`n Continue ??
    IfMsgBox, No
      Return
  }
  FileBusy := 1
  UseProg := 0
  UseDelay := 0
  Use7Prog := 0
  TaskInit := 0
  commentcount := _CountComments(CommentFile)
  min := sd.Count
  max := commentcount
  if (max = min)
  {
    FileBusy := 0
    MsgBox, 4160, Comment Explorer, No Dupes Found in: `n`n %CommentFile%, 4
    Return
  }
  ndupes := max - min
  if (commentcount < 50)
    UseDelay := 1
  if (commentcount > 4)
    UseProg := 1
  IfExist,%CommentFile%
  {
    gosub,BackupComments
    if ErrorLevel
    {
      MsgBox, 4112, Comment Explorer, Error Backing Up:  %CommentFile%
      UseProg := 0
      UseDelay := 0
      Return
    }
    FileDelete,%CommentFile%
  }
  else
  {
    MsgBox, 4112, Comment Explorer, %CommentFile% Not Found!
    FileBusy := 0
    Return
  }  
  if hModule
      Use7Prog := 1  
  if UseProg
  {
    max := sd.count
    Gui, Add, Progress, range0-%max% w300 h20 cBlue vMyProgress
    Gui Show,,%ProgTitle%
    if Use7Prog
    {
      Gui +LastFound
      WinExist()
      Sleep,1000
      if !DllCall("Win7TaskbarLib\win7taskbar_init")
      {
        ;MsgBox, 4112, Comment Explorer, Win7 Progress Init() failed!
        Use7Prog := 0
      }
      else
      {
        if !DllCall("Win7TaskbarLib\win7taskbar_state",UInt,WinExist(),UInt,2)
        {
          ;MsgBox, 4112, Comment Explorer, Win7 Progress State Set Failed!
          Use7Prog := 0
        }
      }
    } 
  }
   min := 1
  for k, v in sd.Keys()
  {
   if sd.exists(k)
   {
    FileAppend,%k%`n,%CommentFile%
    Str := sd.item(k)
    FileAppend,%Str%`n,%CommentFile%
    if UseProg
      GUIcontrol,,MyProgress, +1
    if Use7Prog
    {
      DllCall("Win7TaskbarLib\win7taskbar_progress",UInt,WinExist(),UInt,min,UInt,max) 
      min++
    }
    if UseDelay
      Sleep, 100
    }
  }
  if UseProg
  {
    if Use7Prog
    {
      DllCall("Win7TaskbarLib\win7taskbar_progress",UInt,WinExist(),UInt,0,UInt,max) 
      DllCall("Win7TaskbarLib\win7taskbar_uninit")
    }
    Sleep 250
    Gui Destroy
  }
  if (ProgTitle = "Compacting Comments")
    MsgBox, 4160, Comment Explorer, %ndupes%  Dupes Compacted, 5
  UseProg := 0
  UseDelay := 0
  FileBusy := 0
Return 

BackupComments:
  IfExist,%CommentFile%
  {
    FileBusy := 1
    CommentBackup := CommentFile . ".bak"
    FileCopy,%CommentFile%,%CommentBackup%,1
    if UseProg
      Return
    if ErrorLevel
      MsgBox, 4112, Comment Explorer, Back Up of %CommentFile% Failed!
    else
      MsgBox, 4160, Comment Explorer, %CommentFile% successfully backed up to %CommentBackup%, 5
    FileBusy := 0
  }
  else
    MsgBox, 4112, Comment Explorer, %CommentFile% not found!
Return

SearchComments:
  cmt := "Enter String to Search for in Comments"
  InputBox,cmt,Comment Explorer,%cmt%
  if (cmt = "")
    Return
  if !RegExMatch(cmt,"\S")
    Return
  ;MsgBox, 4160, Comment Explorer, You Entered: %cmt%, 4
  commentcount := 0
  FoundFiles := ""
  for k, v in sd.Keys()
  {
    if sd.exists(k)
    {
      TempStr := sd.item(k)
      ;MsgBox, 4160, Comment Explorer, Haystack is: %TempStr%  -  Needle is: %cmt%
      if InStr(TempStr,cmt)
      {
        ;MsgBox, 4160, Comment Explorer, %k%, 2
        FoundFiles := FoundFiles . k . "`n"
        commentcount++
      }
    }
  }
  if (commentcount > 0)
  {
    FoundFiles := commentcount " File(s) Found with - " . cmt . " - in Comment`n`n" . FoundFiles
    If FileExist(SearchResults)
      FileDelete,%SearchResults%
    FileAppend,%FoundFiles%, %SearchResults%
    ;MsgBox, 4160, Comment Explorer, Matching Files Found: `n %FoundFiles%
    Run,%SearchResults%
  }
  else
    MsgBox, 4160, Comment Explorer, No Files Found with - %cmt% - in Comment
Return

DisableFileFuncs:
  if !FolderMode
    Menu Tray,Disable,Purge Comments
  Menu Tray,Disable,Compact Comments
  Menu Tray,Disable,Back Up Comments
  Menu Tray,Disable,Search Comments
Return

EnableFileFuncs:
  if !FolderMode
    Menu Tray,Enable,Purge Comments
  Menu Tray,Enable,Compact Comments
  Menu Tray,Enable,Back Up Comments
  Menu Tray,Enable,Search Comments
Return

CheckUpdate:
  _CheckForUpdate()
Return

WriteIni:
  IniWrite,%ArrowsEnabled%,%IniFile%,Settings,ArrowsEnabled
  IniWrite,%FolderMode%,%IniFile%,Settings,FolderMode
Return

DoIniFile:
  IniEditActive := 1
  RunWait,%IniFile%
  Sleep 500
  Run,%A_ScriptFullPath%
  
SaveIni:
  if FileBusy
  {
    SetTimer,SaveIni,-1000
    Return
  }
  if IniEditActive =
    gosub,WriteIni
ExitApp

DoReadme:
  Run,Readme.txt
Return

DoQuit:
ExitApp

_CommentFiles(filenames)
{
  global sd ;scripting dictionary
  global CommentFile ; comment data file
  global FolderMode ; use filename only as key
  global FolderCommentFileName ; local folder comment filename
  global CurrentFolder ; local folder
  global PrevFolder ; previous local folder
  
  foldercheck := 0
  key := ""
  
  Loop, parse, filenames, `n, `r
  {
    fname := _FileName(A_LoopField)
    if FolderMode
      key := fname
    else
      key := A_LoopField
    if FolderMode && !foldercheck
    {
      CurrentFolder := _FileDir(A_LoopField)
      if (CurrentFolder != PrevFolder)
      {
        PrevFolder := CurrentFolder
        if sd.count > 0
          sd.removeall()
        CommentFile := _FileDirWithSlash(A_LoopField) . FolderCommentFileName
        gosub,ReadCommentFile
        gosub,EnableFileFuncs
        foldercheck := 1
      }
    }        
    if sd.exists(key)
      cmt := sd.item(key)
    InputBox,cmt,,Enter Comment for %fname%,,,,,,,,%cmt%
    if ErrorLevel
      Return
    sd.item(key) := cmt
    FileAppend,%key%`n,%CommentFile%
    FileAppend,%cmt%`n,%CommentFile%
  }
}

_CopyComments(filenames)
{
  global sd ;scripting dictionary
  global CommentFile ; comment data file
  global FolderMode ; filename only as key
  global FolderCommentFileName ; local folder comment filename
  global CurrentFolder ; local folder
  global PrevFolder ; previous local folder
  
  destfile := CommentFile
  foldercheck := 0
  
  FileSelectFolder, Folder,, 3,Select Target Folder for Comment Copy
  if ErrorLevel
    Return
  Folder := RegExReplace(Folder, "\\$")
  if FolderMode
    destfile := Folder . "\" . FolderCommentFileName
  
  Loop, parse, filenames, `n, `r
  {
    fname := _FileName(A_LoopField)
    if FolderMode && !foldercheck
    {
      CurrentFolder := _FileDir(A_LoopField)
      if (CurrentFolder != PrevFolder)
      {
        PrevFolder := CurrentFolder
        if sd.count > 0
          sd.removeall()
        CommentFile := _FileDirWithSlash(A_LoopField) . FolderCommentFileName
        ;MsgBox, 4160, Comment Explorer, Comment File is: %CommentFile%, 5
        gosub,ReadCommentFile
        gosub,EnableFileFuncs
        foldercheck := 1
      }
    }        
    if FolderMode
      key := fname
    else
      key := A_LoopField
    if !sd.exists(key)
      Continue
    cmt := sd.item(key)
    if Foldermode
      ofname := fname
    else
      ofname := Folder . "\" . fname
    sd.item(ofname) := cmt
    FileAppend,%ofname%`n,%destfile%
    FileAppend,%cmt%`n,%destfile%
  }
  _PromptCopyFiles(Folder)
}

_PromptCopyFiles(Folder)
{
  Global TipActive
  target := _WrapQuotes(Folder)
  Run,Explorer.exe /e`,%target%
  msg := "Comment Copy Completed - Drag Files to Target Folder"
  WinGetPos, xpos, ypos, , , A
  TipActive := 1
  Progress, zh0 B fs12 X%xpos% Y%ypos%, %msg%
  SetTimer,ClearTip,-5000
}

_CountComments(filename)
{
  numlines := 0
  Loop, Read, %filename%
    numlines++
  Return numlines >> 1
}

ClipEmpty()
{
  return (Clipboard = "") ? 1 : 0
}
